/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 CApplicationHelper.h

		Interface for the CApplicationHelper Class

 ******************************************************************************/

#ifndef _CAPPLICATION_HELPER_H_
#define _CAPPLICATION_HELPER_H_

#include "CObject.h"

class CWriter;
class CReader;

class CFileRequest {
	
	public:
		char	mFileName[1024];
		bool	mAppend;
		bool	mOverwrite;
		int		mFormat;
		
		bool	mAskFileName;
		bool	mAskAppend;
		bool	mAskOverwrite;
		bool	mAskFormat;
		
		char*	mFormatNames[100];
		int		mNumFormats;
		
		CFileRequest() {
			mFileName[0] = '\0';
			mAppend = false;
			mOverwrite = false;
			mFormat = 0;
			
			mAskFileName = true;
			mAskAppend = false;
			mAskOverwrite = true;
			mAskFormat = false;
			
			mFormatNames[0] = NULL;
			mNumFormats = 0;
		}		
};
		
class CApplicationHelper : public CObject {
	public:
								CApplicationHelper();
		virtual 				~CApplicationHelper();
		
		virtual CWriter*		createFileWriter(CFileRequest *ioFileRequest);
		virtual CReader*		createFileReader(CFileRequest *ioFileRequest);

};

#endif /* _CAPPLICATION_HELPER_H_ */
