/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 CDataTextWriter.h

		Interface for the CDataTextWriter Class
					
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = "Read/Write"
 
#ifndef _CDATA_TEXT_WRITER_H_
#define _CDATA_TEXT_WRITER_H_

#include "CWriter.h"

//using namespace std;

/******************************************************************************
	class CDataTextWriter
 ******************************************************************************/
#pragma mark CDataTextWriter class

class CDataTextWriter : public CWriter 
{
	protected:
		char				*buffer;
		int					bufLen;
		int					bufPos;

		bool				isCounting;
		int					writeCount;
		
	public:
	 						CDataTextWriter();									
	 						CDataTextWriter(char *inBuffer, int inLength);									
	 	virtual				~CDataTextWriter();

		virtual void 		setBuffer(char *inBuffer, int inLength);
		virtual void 		setIsCounting(bool inCounting=true);
		virtual int 		getCount() { return writeCount; }
		virtual void 		nullTerminate();
		
		virtual void		writeChar(char ch);
		virtual void		writeText(const char *st, int len);
		
		virtual void		writeInteger(int d);
		virtual void		writeInteger(int d, int width);
		virtual void		writeDouble(double f);
		virtual void		writeDouble(double f, int precision, bool scientific = false);
};

#endif /* _CDATA_TEXT_WRITER_H_ */
