/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 CEngineCaller.h

		Interface for the CEngineCaller Class
	
 ******************************************************************************/

#ifndef _CENGINE_CALLER_H_
#define _CENGINE_CALLER_H_

#include "CObject.h"

class CApplication;

class CCommandRecord;
class CReportRecord;

class CEngineCaller : public CObject {
	protected:
		CApplication*			mApplication;
		
	public:
				CEngineCaller(CApplication* inApplication);
		virtual	~CEngineCaller();
		
		virtual CReportRecord*	execute(CCommandRecord *inCommand, bool &outQuit);

	public: 
		virtual CReportRecord*	executeCommand(CCommandRecord *inCommand) = 0;

		virtual CReportRecord*	doRunFile(CCommandRecord *inCommand);
		virtual CReportRecord*	doLoadFile(CCommandRecord *inCommand);

		virtual CReportRecord*	doLog(CCommandRecord *inCommand);

		virtual CReportRecord*	doHelp(CCommandRecord *inCommand);

		virtual bool			doQuit(CCommandRecord *inCommand);
};

#endif /* _CENGINE_CALLER_H_ */
