/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 CHTMLReporter.h

		Interface for the CHTMLReporter Class
	
 ******************************************************************************/

#ifndef _CHTML_REPORTER_H_
#define _CHTML_REPORTER_H_

#include "CReporter.h"

/******************************************************************************
	class CHTMLReporter
 ******************************************************************************/
#pragma mark CHTMLReporter class

class CHTMLReporter : public CReporter {			// Class Declaration
	protected:
		bool						mIsReporting;
		int							mFigureCount;
		
	public:
									CHTMLReporter(CWriter *inWriter, bool inOwner = false);
		virtual 					~CHTMLReporter();

		virtual void				startReport(char *inTitle);
		virtual void				finishReport();
		
		virtual void				writeReport(CReportRecord *inReport);

	protected:
		virtual void				writeOpenStyle(CStyledElement *inElement);
		virtual void				writeCloseStyle(CStyledElement *inElement);

		virtual void				writeOpenLink(CReportElement *inElement);
		virtual void				writeCloseLink(CReportElement *inElement);

		virtual void				writeSimpleElement(char *inTag, 
														ElementAlignment inAlign, 
														CSimpleElement *inElement,
														bool inIndent = false);

		virtual void				writeComplexElement(char *inTag, 
														ElementAlignment inAlign, 
														CComplexElement *inElement,
														bool inIndent = false);

		virtual void				writeFilteredString(const char *st);
		
		virtual void				writeText(CTextElement *inElement);
		virtual void				writeLineBreak(CLineBreakElement *inElement);
		virtual void				writeInteger(CIntegerElement *inElement);
		virtual void				writeReal(CRealElement *inElement);
		virtual void				writeToken(CTokenElement *inElement);
		virtual void				writeParagraph(CParagraphElement *inElement);
		virtual void				writePreformatted(CPreformattedElement *inElement);
		virtual void				writeTable(CTableElement *inElement);
		virtual void				writeList(CListElement *inElement);

		virtual void				writeFigure(CFigureElement *inElement);
};

#endif /* _CHTML_REPORTER_H_ */
