// =================================================================================
//	CPhylogenyPlot.h					2002 Andrew Rambaut. All rights reserved.
// =================================================================================

#pragma once

#include "CPlot.h"

#include "CGraphicsRecord.h"

class MEPhylogeny;
class CComplexGraphicElement;

class CPhylogenyPlot : public CPlot {

protected:
	MEPhylogeny			*mPhylogeny;
	
	long				mNumExtant;
	double				mOrigin;
	double				mHeight;
	double				mDelta;

public:
	//====<<  METHODS  >>============================================================
		
	//----<<  INITIALIZATION & DISPOSAL  >>------------------------------------------

 						CPhylogenyPlot( );
	
	virtual	void		SetPhylogeny(MEPhylogeny *inPhylogeny);
	virtual	MEPhylogeny *GetPhylogeny() { return mPhylogeny; }
	
	//----<<  DRAWING  >>--------------------------------------------------------
	
	virtual	void		DrawPlot(CComplexGraphicElement *ioGraphic, 
									double inXTolerance = 0.0, 
									double inYTolerance = 0.0 );
									
	virtual	void		DrawDataSeries(CComplexGraphicElement *ioGraphic, 
									CDataSeries *inData, 
									double inXTolerance = 0.0, 
									double inYTolerance = 0.0 ) { };
	
protected:
	virtual	void		DrawPhylogeny(CComplexGraphicElement *ioGraphic);
	virtual	void		DrawLineage(CComplexGraphicElement *ioGraphic, long inLineage, double &ioY);
};
