/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	CProgress.cpp

		Interface for the CProgress Class
				
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = Global

#ifndef _CPROGRESS_H_
#define _CPROGRESS_H_

#include "CObject.h"

/******************************************************************************
	class CProgress
 ******************************************************************************/
#pragma mark CProgress class

class CProgress : public CObject {
	protected:
		int						skip;
		bool					suspend;
		
		int 					numSubdivisions;
		int						currSubdivision;
		
	public:
								CProgress();
		virtual 				~CProgress();
	
		virtual void			reset() = 0;
		virtual void			complete() { }
		virtual void			setSuspend(bool inSuspend) { suspend = inSuspend; }

		virtual void			setSkip(int inSkip) { skip=inSkip; }
		virtual void			setNumSubdivisions(int inNumSubdivisions) 
									{ 	numSubdivisions = inNumSubdivisions; 
										currSubdivision = 0; }
		virtual void			setCurrSubdivision(int inCurrSubdivision) 
									{ currSubdivision = inCurrSubdivision; }

		virtual void			description(char* message);
		virtual void			score(double value);

		virtual void			yield() { }
		
		virtual bool			progress(int count=0);
		virtual bool			progress(int count, int total);
		virtual bool			progress(int count, double value=0.0);
		virtual bool			progress(int count, char* message);
		virtual bool			progress(int count, int total, char* message);
};

#endif /* _CPROGRESS_H_ */

