/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 CReporter.h

		Interface for the CReporter Class
	
 ******************************************************************************/

#ifndef _CREPORTER_H_
#define _CREPORTER_H_

#include "CObject.h"

class CWriter;
class CReportElement;
class CTextElement;
class CLineBreakElement;
class CIntegerElement;
class CRealElement;
class CTokenElement;
class CParagraphElement;
class CPreformattedElement;
class CTableElement;
class CListElement;
class CFigureElement;
class CReportRecord;

/******************************************************************************
	class CReporter
 ******************************************************************************/
#pragma mark CReporter class

class CReporter : public CObject {			// Class Declaration
	protected:
		CWriter*					writer;		
		bool						isOwner;
		
	public:
									CReporter(CWriter *inWriter, bool inOwner = false);
		virtual 					~CReporter();
		
		virtual void				writeReport(CReportRecord *inReportRecord);
		
	protected:
		virtual void				writeElement(CReportElement *inElement);
		
		virtual void				writeText(CTextElement *inElement);
		virtual void				writeLineBreak(CLineBreakElement *inElement);
		virtual void				writeInteger(CIntegerElement *inElement);
		virtual void				writeReal(CRealElement *inElement);
		virtual void				writeToken(CTokenElement *inElement);
		virtual void				writeParagraph(CParagraphElement *inElement);
		virtual void				writePreformatted(CPreformattedElement *inElement);
		virtual void				writeTable(CTableElement *inElement);
		virtual void				writeList(CListElement *inElement);

		virtual void				writeFigure(CFigureElement *inElement);
};

#endif /* _CREPORTER_H_ */
