/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 CSVGReporter.h

		Interface for the CSVGReporter Class
	
 ******************************************************************************/

#ifndef _CSVG_REPORTER_H_
#define _CSVG_REPORTER_H_

#include "CReporter.h"
#include "CGraphicsRecord.h"

/******************************************************************************
	class CSVGReporter
 ******************************************************************************/
#pragma mark CSVGReporter class

class CSVGReporter : public CReporter {			// Class Declaration
	protected:
		bool						isReporting;
		
	public:
									CSVGReporter(CWriter *inWriter, bool inOwner = false);
		virtual 					~CSVGReporter();

		virtual void				startReport(char *inTitle);
		virtual void				finishReport();
		
		virtual void				writeReport(CReportRecord *inReport);
		virtual void				writeFigure(CFigureElement *inElement);

	protected:
		virtual void				writeElement(CReportElement *inElement);

		virtual void				writeAtt(char *name, double value);
		virtual void				writeViewBox(CViewPortElement *inElement);
		virtual void				writeTransformations(CGraphicElement *inElement);

		virtual void				writeColour(ColourType inType, double inR, double inG, double inB);
		virtual void				writeStrokeStyle(CGraphicElement *inElement);
		virtual void				writeStrokeFillStyle(CGraphicElement *inElement);
		virtual void				writeTextStyle(CTextGraphicElement *inElement);

		virtual void				writeLine(CLineElement *inElement);
		virtual void				writeRect(CRectElement *inElement);
		virtual void				writeRoundedRect(CRoundedRectElement *inElement);
		virtual void				writeCircle(CCircleElement *inElement);
		virtual void				writeEllipse(CEllipseElement *inElement);
		virtual void				writeTextGraphic(CTextGraphicElement *inElement);
		
		virtual void				writeCode(char code, double value);
		virtual void				writeCode(char code, double value1, double value2);
		virtual void				writePath(CPathElement *inElement);
		
		virtual void				writeGroup(CGroupElement *inElement);
		virtual void				writeViewPort(CViewPortElement *inElement);
};

#endif /* _CSVG_REPORTER_H_ */
