/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 CScatterPlot.cpp
 
		CScatterPlot Class
	 
 ******************************************************************************/

#include "CScatterPlot.h"
#include "CDataSeries.h"
#include "CDoubleArray.h"
#include "CGraphicsRecord.h"

#pragma mark === Construction & Destruction ===

// ---------------------------------------------------------------------------------
//		 CScatterPlot()
// ---------------------------------------------------------------------------------

CScatterPlot::CScatterPlot( ) : CPlot( )
{
}

#pragma mark === Drawing ===

//------------------------------------------------------------------------------------
// 		CScatterPlot::DrawDataSeries
//-------------------------------------------------------------------------------------

void CScatterPlot::DrawDataSeries(CComplexGraphicElement *ioGraphic, 
									CDataSeries *inData,
									double inXTolerance, 
									double inYTolerance)
{
	CDoubleArray *xData = inData->GetXData();
	CDoubleArray *yData = inData->GetYData();
	
	CDoubleArray *yHigh = NULL;
	CDoubleArray *yLow = NULL;
	if (inData->GetHasLimits()) {
		yHigh = inData->GetYHigh();
		yLow = inData->GetYLow();
	}
	
	int n = xData->getNumValues();
	for (int i=0; i<n; i++) {
		
		if (yHigh != NULL) {
			DrawLine(ioGraphic, mLineGraphic, xData->getValue(i), yHigh->getValue(i),
						xData->getValue(i), yLow->getValue(i));
		}
		
		DrawMark(ioGraphic, mMarkGraphic, xData->getValue(i), yData->getValue(i));
	}
}


