/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 CStringReader.h

		Interface for the Reader Class

 ******************************************************************************/
 
#ifndef _CSTRING_READER_H_
#define _CSTRING_READER_H_

#include "CReader.h"

/******************************************************************************
	class CStringReader
 ******************************************************************************/
#pragma mark CStringReader class

class CStringReader : public CReader {
	public:
		char*					mString;
		char*					mPosition;
		char*					mMarked;
		
	public:
	 							CStringReader();						
	 														
		virtual void 			setString(char *inString);
		
		virtual void 			markPosition();
		virtual void 			restorePosition();
		
		virtual char 			readChar();
		virtual char 			nextChar();
		virtual void 			unreadChar(char ch);
};

#endif /* _CSTRING_READER_H_ */
