/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	CTextProgress.h

		Interface for the CTextProgress Class
				
 ******************************************************************************/

#ifndef _CTEXT_PROGRESS_H_
#define _CTEXT_PROGRESS_H_

#include <iostream>

#include "CProgress.h"

/******************************************************************************
	class TextProgress
 ******************************************************************************/
#pragma mark CTextProgress class

class CTextProgress : public CProgress {
	protected:
		std::ostream*			stream;
		
		int						barLength, dots;
		bool					hasDrawnBar;
		
	public:
								CTextProgress(std::ostream *inStream, int inBarLength = 20);
		virtual 				~CTextProgress();
	
		virtual void 			setStream(std::ostream *inStream);

		virtual void			reset();
		virtual void			complete();
				
	protected:
		void					drawBar();

	public:
		virtual void			description(char* message);

		virtual bool			progress(int count, int total);
		virtual bool			progress(int count, double value);
};

#endif /* _TEXT_PROGRESS_H_ */

