/******************************************************************************

ZooCore C++ Class Library (ZooCoreLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of ZooCoreLib C++ Class Library.

    ZooCoreLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZooCoreLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 CWriter.h

		Interface for the CWriter Class
					
 ******************************************************************************/
 
#ifndef _CWRITER_H_
#define _CWRITER_H_

#include "CObject.h"

/******************************************************************************
	class CWriter
 ******************************************************************************/
#pragma mark CWriter class

class CWriter : public CObject {
	public:
	 						CWriter();									
	 	virtual				~CWriter();

		// Abstract functions to be overridden
		virtual void		writeChar(char ch) = 0;
		virtual void		writeText(const char *st, int len) = 0;
		
		virtual void		writeInteger(int d) = 0;
		virtual void		writeInteger(int d, int width) = 0;
		virtual void		writeDouble(double f) = 0;
		virtual void		writeDouble(double f, int precision, bool scientific = false) = 0;
		
		// Higher level functions that utilise the above
		virtual void		writeString(const char *st);
		virtual void		writePString(const char *st);
		
		virtual int			getLabelLength(const char *st, bool allowPunctuation=false);
		virtual void		writeLabel(const char *st, bool allowPunctuation=false);
		
		virtual void 		writeSpaces(int n);
		virtual void 		writeTabs(int n);
		virtual void 		writeEndLine(int n = 1);
};

#endif /* _CWRITER_H_ */
