/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEBasicAlignmentList.h

		Interface for the MEBasicAlignmentList Class
					
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = "Sequences"
 
#ifndef _MEBASIC_ALIGNMENT_LIST_H_
#define _MEBASIC_ALIGNMENT_LIST_H_

#include "MEList.h"

class MEStream;

/******************************************************************************
	class MEBasicAlignmentList
 ******************************************************************************/
#pragma mark MEBasicAlignmentList class

class MEBasicAlignmentList : public MEList {
	public:
		virtual long		getID() const { return 'MBAL'; }
		//: The ID of this object - 'MBAL'.
		
		virtual char*		getClassName() const { return "Basic Alignment List"; }
		//: Returns the name of this class - "Basic Alignment List"
		
	public:
	 						MEBasicAlignmentList();						
	 	virtual				~MEBasicAlignmentList();
	 	
		virtual MEObject*	createObject();

		virtual void		readObject(MEStream *stream);
		virtual void		writeObject(MEStream *stream);
};

#endif /* _MEBASIC_ALIGNMENT_LIST_H_ */

