/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MECreatorUtils.h

		Interface for the MECreatorUtils Class
	
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = "File Creating"

#ifndef _MECREATOR_UTILS_H_
#define _MECREATOR_UTILS_H_

#include "MEGlobal.h"

class CWriter;
class MECreator;
class MEBasicAlignment;
class METreeList;
class METree;

/******************************************************************************
	class MECreatorUtils
 ******************************************************************************/
#pragma mark MECreatorUtils class

class MECreatorUtils {			// Class Declaration
	public:
		static void create(CWriter *inWriter, FormatType format, bool interleaved, 
							MEBasicAlignment *inAlignment);
		static void create(CWriter *inWriter, FormatType format, bool interleaved, 
							METree *inTree);
		static void create(CWriter *inWriter, FormatType format, bool interleaved, 
							METreeList *inTreeList);
		static void create(CWriter *inWriter, FormatType format, bool interleaved, 
							MEBasicAlignment *inAlignment, METree *inTree);
		static void create(CWriter *inWriter, FormatType format, bool interleaved, 
							MEBasicAlignment *inAlignment, METreeList *inTreeList);
							
		static MECreator* createCreator(CWriter *inWriter, FormatType format, 
										bool interleaved);
};

#endif /* _MECREATOR_UTILS_H_ */
