/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	MECriterion.cpp

		Class: MECriterion

	This class provides a base for algorithms requiring an optimality criterion.

 ******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "MEPatternList.h"
#include "MECriterion.h"

#pragma mark === MECriterion ===

// ---------------------------------------------------------------------------------
//		 MECriterion
// ---------------------------------------------------------------------------------

MECriterion::MECriterion()
{
	score=0.0;
	scoreKnown=false;
}

// ---------------------------------------------------------------------------------
//		 MECriterion::getScore
// ---------------------------------------------------------------------------------

double MECriterion::getScore()
{
	if (!scoreKnown)
		calcScore();
		
	return score;
}

// ---------------------------------------------------------------------------------
//		 MECriterion::invalidate
// ---------------------------------------------------------------------------------

void MECriterion::invalidate()
{
	scoreKnown=false;
}


char
	critmsg[512];
	
// ---------------------------------------------------------------------------------
//		 MECriterion::write
// ---------------------------------------------------------------------------------
char* MECriterion::write(char *str)
{
	sprintf(critmsg, "MECriterion: score = %f", getScore());
	if (str)
		strcpy(str, critmsg);
	return critmsg;
}

