/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEDataMatrixList.cpp

				MEDataMatrixList Class
				
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "MEGlobal.h"
#include "MEExceptions.h"

#include "MEDataMatrixList.h"
#include "MEDataMatrix.h"

#include "MEStream.h"


#pragma mark === MEDataMatrixList ===

// ---------------------------------------------------------------------------------
//		 MEDataMatrixList
// ---------------------------------------------------------------------------------

MEDataMatrixList::MEDataMatrixList() : METaxonMatrixList()
{
}

// ---------------------------------------------------------------------------------
//		 ~MEDataMatrixList
// ---------------------------------------------------------------------------------

MEDataMatrixList::~MEDataMatrixList()
{
}

// ---------------------------------------------------------------------------------
//		MEDataMatrixList::createObject
// ---------------------------------------------------------------------------------

MEObject* MEDataMatrixList::createObject()
{
	MEObject *obj;
	NewClass(obj, MEDataMatrix());
	return obj;
}

// ---------------------------------------------------------------------------------
//		 MEDataMatrixList::newMatrix
// ---------------------------------------------------------------------------------

MEMatrix *MEDataMatrixList::newMatrix()
{
	MEDataMatrix *matrix=(MEDataMatrix*)createObject();

	matrix->setOwner(this);
	
	if (taxonList!=NULL)
		matrix->setTaxonList(taxonList, false);
	
	return matrix;
}

#pragma mark === Object I/O ===

// ---------------------------------------------------------------------------------
//		 MEDataMatrixList::readObject
// ---------------------------------------------------------------------------------

void MEDataMatrixList::readObject(MEStream *stream)
{
	METaxonMatrixList::readObject(stream);
}

// ---------------------------------------------------------------------------------
//		 MEDataMatrixList::writeObject
// ---------------------------------------------------------------------------------

void MEDataMatrixList::writeObject(MEStream *stream)
{
	METaxonMatrixList::writeObject(stream);
}


