/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEDataTextStream.h

		Interface for the MEDataTextStream Class
					
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = "Read/Write"
 
#ifndef _MEDATA_TEXT_STREAM_H_
#define _MEDATA_TEXT_STREAM_H_

#include <iostream.h>

#include "METextStream.h"

class MEObject;
class MEUndead;
class MEList;
class METree;
class MELink;
union ObjectID;

//using namespace std;

/******************************************************************************
	class MEDataTextStream
 ******************************************************************************/
#pragma mark MEDataTextStream class

class MEDataTextStream : public METextStream
{
	protected:
		char					*buffer;
		int						bufLen;
		int						bufPos;

		bool					isCounting;
		int						writeCount;
		
	public:
	 							MEDataTextStream();						
	 							MEDataTextStream(char *inBuffer, int inLength);						
	 	virtual					~MEDataTextStream();

		virtual void 			setBuffer(char *inBuffer, int inLength);
		
		virtual void 			setIsCounting(bool inCounting=true);
		virtual int 			getCount() { return writeCount; }

		virtual char 			readChar();
		virtual char 			nextChar();
		
		virtual void			writeChar(char ch);
		virtual void			writeText(const char *st, int len);
		virtual void			writeInteger(int d);
		virtual void			writeDouble(double f);
};

#endif /* _MEDATA_TEXT_STREAM_H_ */
