/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEFASTACreator.h

		Interface for the MEFASTACreator Class
	
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = "File Creating"

#ifndef _MEFASTA_CREATOR_H_
#define _MEFASTA_CREATOR_H_

#include "MECreator.h"

class CWriter;
class MEBasicAlignment;
class METree;
class METreeList;
class MEMatrix;
class MEDistanceMatrix;

/******************************************************************************
	class MEFASTACreator
 ******************************************************************************/
#pragma mark MEFASTACreator class

class MEFASTACreator : public MECreator {
	protected:
				
	public:
		MEFASTACreator();
		MEFASTACreator(CWriter *inWriter);
	
		virtual void		createAlignment(MEBasicAlignment *inAlignment);
	
		virtual void		finishCreation() { }

	protected:
		virtual void		writeSequenceData(MEBasicAlignment *inAlignment);
};

#endif /* _MEFASTA_CREATOR_H_ */
