/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEFlatCreator.cpp

				MEFlatCreator Class
	
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "MEExceptions.h"
#include "CWriter.h"
#include "MECreator.h"
#include "MEFlatCreator.h"
#include "MEBasicSequence.h"
#include "MEBasicAlignment.h"


/******************************************************************************
 MEFlatCreator
 
 ******************************************************************************/

MEFlatCreator::MEFlatCreator() : MECreator()
{
}


MEFlatCreator::MEFlatCreator(CWriter *inWriter) : 
	MECreator(inWriter)
{
}


void MEFlatCreator::writeSequenceData(MEBasicAlignment *inAlignment)
{
	int i, n, m, nameLen;
	char *name;
	AlignmentType type = inAlignment->getAlignmentType();
	
	n=inAlignment->getNumTaxa();
	m=inAlignment->getNumSites();
		
	char *str;
	int len=inAlignment->getStringLength(0, m)+1;
//	NewArray(str, char, len);
	str = new char[len];
	
	for (i=0; i<n; i++) {
		name=inAlignment->getSequenceName(i);
		if (type == kAminoAcidAlignment)
			writer->writeChar('%');
		else
			writer->writeChar('#');
		writer->writeString(name);
		writer->writeChar('\r');
		inAlignment->getSequenceString(i, str, m);
		writeSequence(str, m, 80, 0, 0);
		writer->writeChar('\r');
	}
}

void MEFlatCreator::createAlignment(MEBasicAlignment *inAlignment)
{
	writeSequenceData(inAlignment);
}


