/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEGenbankParser.h

		Interface for the MEGenbankParser Class
	
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = "File Parsing"

#ifndef _MEGENBANK_PARSER_H_
#define _MEGENBANK_PARSER_H_

#include "MEParser.h"

class CReader;
class MEBasicAlignment;
class MEFeature;
class MESequence;

class MEGenbankParser : public MEParser {
	protected:
		bool			parseFeatures;
		int*			exonRanges;
		int				numExons, capacity;
		
		bool			originFound;
		
	public:
						MEGenbankParser(CReader *inReader);
		virtual			~MEGenbankParser();
	
		void			setParseFeatures(bool inParseFeatures) { parseFeatures=inParseFeatures; }
		
	protected:
		void			checkExonCapacity(int newCapacity);
		int 			getNextTag(char *token);
		int 			findTag(char *token, int indent);
		
		void			readFeatureRange();
		void			readFeatures(MESequence *sequence);
		
	public:
		virtual void	readAlignment(MEBasicAlignment *inAlignment);
		
};

#endif /* _MEGENBANK_PARSER_H_ */
