/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEGenealogy.h

		Interface for the MEGenealogy Class
					
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = "Trees" 
 
#ifndef _MEGENEALOGY_H_
#define _MEGENEALOGY_H_

#include "MEVariate.h"

class MEStream;

/******************************************************************************
	class MEGenealogy
 ******************************************************************************/
#pragma mark MEGenealogy class

class MEGenealogy : public MEVariate {
	public:
		virtual long		getID() const { return 'MGen'; }
		//: The ID of this object - 'MGen'.

		virtual char*		getClassName() const { return "Genealogy"; }
		//: Returns the name of this class - "Genealogy"
		
	public:
							MEGenealogy();
	 	virtual				~MEGenealogy();
		
	public:
		int					getNumIntervals() { return getN(); }
		virtual double		getInterval(int index) { return getVal(index); }
		virtual void		setInterval(int index, double f) { setVal(index, f); }
};

#endif /* _MEGENEALOGY_H_ */
