/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEMatrixList.cpp

				MEMatrixList Class
				
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "MEGlobal.h"
#include "MEExceptions.h"

#include "MEMatrixList.h"
#include "MEMatrix.h"

#include "MEStream.h"


#pragma mark === MEMatrixList ===

// ---------------------------------------------------------------------------------
//		 MEMatrixList
// ---------------------------------------------------------------------------------

MEMatrixList::MEMatrixList() : 
	MEList()
{
}

// ---------------------------------------------------------------------------------
//		 ~MEMatrixList
// ---------------------------------------------------------------------------------

MEMatrixList::~MEMatrixList()
{
}

// ---------------------------------------------------------------------------------
//		MEMatrixList::createObject
// ---------------------------------------------------------------------------------

MEObject* MEMatrixList::createObject()
{
	MEObject *obj;
	NewClass(obj, MEMatrix());
	return obj;
}

// ---------------------------------------------------------------------------------
//		 MEMatrixList::getMatrix
// ---------------------------------------------------------------------------------

MEMatrix* MEMatrixList::getMatrix(int index)
{
	return (MEMatrix *)getObject(index);
}

// ---------------------------------------------------------------------------------
//		 MEMatrixList::addMatrix
// ---------------------------------------------------------------------------------

int MEMatrixList::addMatrix(MEMatrix *inMatrix)
{
	return add(inMatrix, inMatrix->getOwner()==NULL);
}

// ---------------------------------------------------------------------------------
//		 MEMatrixList::insertMatrix
// ---------------------------------------------------------------------------------

void MEMatrixList::insertMatrix(int index, MEMatrix *inMatrix)
{
	insert(index, inMatrix, inMatrix->getOwner()==NULL);
}

// ---------------------------------------------------------------------------------
//		 MEMatrixList::removeMatrix
// ---------------------------------------------------------------------------------

MEMatrix* MEMatrixList::removeMatrix(int index)
{
	return (MEMatrix *)remove(index);
}


// ---------------------------------------------------------------------------------
//		 MEMatrixList::newMatrix
// ---------------------------------------------------------------------------------

MEMatrix *MEMatrixList::newMatrix()
{
	MEMatrix *matrix=(MEMatrix*)createObject();
	return matrix;
}

#pragma mark === Object I/O ===

// ---------------------------------------------------------------------------------
//		 MEMatrixList::readObject
// ---------------------------------------------------------------------------------

void MEMatrixList::readObject(MEStream *stream)
{
	MEList::readObject(stream);
}

// ---------------------------------------------------------------------------------
//		 MEMatrixList::writeObject
// ---------------------------------------------------------------------------------

void MEMatrixList::writeObject(MEStream *stream)
{
	MEList::writeObject(stream);
}


