/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEMatrixList.h

		Interface for the MEMatrixList Class

 ******************************************************************************/
//! author = "Andrew Rambaut & Mike Charleston"
//! group = "Matrices"
 
#ifndef _MEMATRIX_LIST_H_
#define _MEMATRIX_LIST_H_

#include "MEList.h"

class MEMatrix;

class MEStream;

/******************************************************************************
	class MEMatrixList
 ******************************************************************************/
#pragma mark MEMatrixList class

class MEMatrixList : public MEList {
	public:
		virtual long		getID() const { return 'MMaL'; }
		//: The ID of this object - 'MMaL'.
		
		virtual char*		getClassName() const { return "Matrix List"; }
		//: Returns the name of this class - "Matrix List"
		
	public:
	 						MEMatrixList();						
	 	virtual				~MEMatrixList();
	 	
		virtual int			getNumMatrices() { return numObjects; };
		
		virtual MEObject*	createObject();

		virtual MEMatrix*	getMatrix(int index);
		
		virtual int			addMatrix(MEMatrix *inMatrix);
		virtual void		insertMatrix(int index, MEMatrix *inMatrix);
		virtual MEMatrix*	removeMatrix(int index);

		virtual MEMatrix*	newMatrix();
	 	
		virtual void		readObject(MEStream *stream);
		virtual void		writeObject(MEStream *stream);
};

#endif /* _MEMATRIX_LIST_H_ */

