/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEPamlCreator.cpp

				MEPamlCreator Class
	
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "CWriter.h"
#include "MECreator.h"
#include "MEPamlCreator.h"
#include "METreeList.h"
#include "METree.h"


void MEPamlCreator::createTree(METree *inTree)
{	
	writer->writeInteger(inTree->getNumTips());
	writer->writeString(" 1\r");
	writeTree(inTree);
	writer->writeChar('\r');
}

void MEPamlCreator::createTreeList(METreeList *inTreeList)
{	
	int i, n;
	
	n=inTreeList->getNumTrees();
	writer->writeInteger(inTreeList->getTree(0)->getNumTips());
	writer->writeChar(' ');
	writer->writeInteger(n);
	writer->writeChar('\r');
	
	for (i=0; i<n; i++) {
		writeTree(inTreeList->getTree(i));
		writer->writeChar('\r');
	}
}
