/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEPhylogenyList.h

		Interface for the MEPhylogenyList Class
					
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = "Trees"
 
#ifndef _MEPHYLOGENY_LIST_H_
#define _MEPHYLOGENY_LIST_H_

#include "MEList.h"

class MEPhylogeny;
class MEStream;

/******************************************************************************
	class MEPhylogenyList
 ******************************************************************************/
#pragma mark MEPhylogenyList class

class MEPhylogenyList : public MEList {
	public:
		virtual long			getID() const { return 'MPhL'; }
		//: The ID of this object - 'MPhL'.
		
		virtual char*			getClassName() const { return "Phylogeny List"; }
		//: Returns the name of this class - "Phylogeny List"
		
	public:
	 							MEPhylogenyList();						
	 	virtual					~MEPhylogenyList();
	 	
		virtual int				getNumPhylogenies() { return numObjects; };
		
		virtual MEObject*		createObject();
		
		virtual MEPhylogeny*	getPhylogeny(int index);
		
		virtual int				addPhylogeny(MEPhylogeny *inPhylogeny);
		virtual void			insertPhylogeny(int index, MEPhylogeny *inPhylogeny);
		virtual MEPhylogeny*	removePhylogeny(int index);

		virtual int				getMemoryUsage();

		virtual void			readObject(MEStream *stream);
		virtual void			writeObject(MEStream *stream);
};

#endif /* _MEPHYLOGENY_LIST_H_ */

