/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEPrettyCreator.cpp

				MEPrettyCreator Class
	
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "MEExceptions.h"

#include "CWriter.h"
#include "MECreator.h"
#include "MEPrettyCreator.h"
#include "MEBasicSequence.h"
#include "MEBasicAlignment.h"


/******************************************************************************
 MEPrettyCreator
 
 ******************************************************************************/

MEPrettyCreator::MEPrettyCreator() : MECreator()
{
	setIsInterleaved(true);
}


MEPrettyCreator::MEPrettyCreator(CWriter *inWriter) : MECreator(inWriter)
{
	setIsInterleaved(true);
}


void MEPrettyCreator::createAlignment(MEBasicAlignment *inAlignment)
{
	writeSequenceData(inAlignment, 0, 0, false, true, true, true, false, true, 10);
}


