/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 METabCreator.h

		Interface for the METabCreator Class
	
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = "File Creating"

#ifndef _METABCREATOR_H_
#define _METABCREATOR_H_

#include "MECreator.h"

class CWriter;
class MEBasicAlignment;
class METree;
class METreeList;
class MEMatrix;
class MEDistanceMatrix;

/******************************************************************************
	class METabCreator
 ******************************************************************************/
#pragma mark METabCreator class

class METabCreator : public MECreator {
	protected:
		bool				writeColumns;
		
	public:
							METabCreator();
							METabCreator(CWriter *inWriter);
							METabCreator(CWriter *inWriter, bool isInterleaved);
	
		virtual void		setWriteColumns(bool inWriteColumns) { writeColumns = inWriteColumns; }

		virtual void 		createDistanceMatrix(MEDistanceMatrix *inDistanceMatrix);

		virtual void		finishCreation() {};

	protected:
		virtual void 		writeMatrixData(MEMatrix *inMatrix);
};

#endif /* _METABCREATOR_H_ */
