/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 METaxon.cpp

				METaxon Class
				
 ******************************************************************************/

// METaxon is a simple class which provides a container for a taxon. As this
// actually consists of a name and a description, METaxon does not add anything
// to MEObject but makes the code more obvious. Additional field could be added
// at a later date (taxonomic information - level i.e. Genus, Family etc.).

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "MEStream.h"
#include "MEObject.h"
#include "METaxon.h"


#pragma mark === METaxon ===

// ---------------------------------------------------------------------------------
//		 METaxon
// ---------------------------------------------------------------------------------

METaxon::METaxon() : MEObject()
{
}

// ---------------------------------------------------------------------------------
//		 ~METaxon
// ---------------------------------------------------------------------------------

METaxon::~METaxon()
{
}

// ---------------------------------------------------------------------------------
//		 METaxon::readObject
// ---------------------------------------------------------------------------------

// Just call the MEObject base function - there are no additional fields at present.
void METaxon::readObject(MEStream *stream)
{
	MEObject::readObject(stream);
}

// ---------------------------------------------------------------------------------
//		 METaxon::writeObject
// ---------------------------------------------------------------------------------

// Just call the MEObject base function - there are no additional fields at present.
void METaxon::writeObject(MEStream *stream)
{
	MEObject::writeObject(stream);
}


