/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 METaxonMatrixList.h

		Interface for the METaxonMatrixList Class

 ******************************************************************************/
//! author = "Andrew Rambaut & Mike Charleston"
//! group = "Matrices"
 
#ifndef _METAXON_MATRIX_LIST_H_
#define _METAXON_MATRIX_LIST_H_

#include "MEMatrixList.h"

class MEMatrix;
class METaxonList;

class MEStream;

/******************************************************************************
	class METaxonMatrixList
 ******************************************************************************/
#pragma mark METaxonMatrixList class

class METaxonMatrixList : public MEMatrixList {
	public:
		virtual long		getID() const { return 'MTML'; }
		//: The ID of this object - 'MTML'.
		
		virtual char*		getClassName() const { return "Taxon Matrix List"; }
		//: Returns the name of this class - "Taxon Matrix List"
		
	protected:
		METaxonList			*taxonList;
		
	public:
	 						METaxonMatrixList();						
	 	virtual				~METaxonMatrixList();
	 	
		virtual MEObject*	createObject();

		virtual void		setTaxonList(METaxonList *inTaxonList, bool isOwner, bool merge=false);
		virtual METaxonList *getTaxonList() { return taxonList; };

		virtual MEMatrix*	newMatrix();
	 	
		virtual void		readObject(MEStream *stream);
		virtual void		writeObject(MEStream *stream);
};

#endif /* _METAXON_MATRIX_LIST_H_ */

