/******************************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	METipDateTreeCriterion.cpp

		Interface for the METipDateTreeCriterion Class
				
 ******************************************************************************/
//! author = "Andrew Rambaut"
//! group = Analysis

#ifndef _METIPDATE_TREE_CRITERION_H_
#define _METIPDATE_TREE_CRITERION_H_

#include "MESandersonTreeCriterion.h"

class MELink;
class METree;


/******************************************************************************
	class METipDateTreeCriterion
 ******************************************************************************/
#pragma mark METipDateTreeCriterion class

//:	This class provides a simple parsimony criterion for a pattern list given a tree
class METipDateTreeCriterion : public MESandersonTreeCriterion {
	public:
								METipDateTreeCriterion();
		virtual					~METipDateTreeCriterion();
								
		virtual void 			setTree(METree *inTree);

		virtual int				getNumParameters();
		virtual double			getValue(int inIndex);
		virtual double			getMinValue(int inIndex);
		virtual double			getMaxValue(int inIndex);
		virtual void			setValue(int inIndex, double inValue);

	protected:
		virtual double			nodeHeightsToValues(MELink *inNode);
		virtual void			heightsToValues();

		virtual double			nodeValuesToHeights(MELink *inNode);
		virtual void			valuesToHeights();

};

#endif /* _METIPDATE_TREE_CRITERION_H_ */

