/******************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEUtilities.cpp

 ******************************************************************/

//  includes:
// C/C++:
#include <ctype.h>
#include <math.h>
#include <iostream.h>
#include <string.h>
#include <stdio.h>

#include "MEUtilities.h"

// variables:
bool
	_debugging = false;
	
// methods:


// IndentStrm
void IndentStrm(ostream &os, int indent)
{
	for (int i = 0; i < indent; i++)
		os << "\t";
}


double sign(double a, double b)
{
	return (b >= 0.0 ? fabs(a) : -fabs(a));
}


void shift(double &a, double &b, double &c, double d)
{
	a=b; b=c; c=d;
}


bool CycleMod(int *A, int dim, int mn, int mx)
//: Loop through an array $A of $dim integers in ([$mn,$mx], ..., $[mn,$mx])
// Increment the least significant integer a_i than is less than mx, taking care
// of overflow, and set the following integers to a_{i+1}, a_{i+2} etc. to mn.
{
	int i, j, pos = dim-1;
	do {
		j = A[pos];
		if (j < mx) {
			A[pos] = j+1;
			for (i = pos; i < dim; i++)
				A[i] = mn;
			break;
		}
		else
			pos--;
	} while (pos >= 0);
	if (pos < 0) {
		for (i = 0; i < dim; i++)
			A[i] = mn;
		return false;
	}
	return true;
}

