/******************************************************************

Molecular Evolution C++ Class Library (MolEvolLib) v1.0
Copyright (C) 1997-2002 Andrew Rambaut and Michael Charleston, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of MolEvolLib C++ Class Library.

    MolEvolLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolEvolLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 MEUtilities.h
 
 ******************************************************************/


#ifndef MEUTILITIES_H
#define MEUTILITIES_H

// includes:
#include <iostream.h>

//  constants
// enums:
enum numbase { decimal, octal, binary, hexadecimal };
enum SortOrder { unsorted, ascending, descending, byRank, byIndex, byValue };
// numbers:
/*
#define None				0
#define AFew 				8
#define Several				64
#define Many				1024
#define Lots				65536
#define Shitloads			1048576
#define AllThereAre			1073741824
*/

// defines:
#define kLoopNameLength 128

// macros:
#ifdef DEBUGGING
extern bool _debugging;

#define DEBUG(a) { if (_debugging) a; }
#else
#define DEBUG(a) {}
#endif

//  strings & characters:
#define EOLN '\n'
#define kKeywordLength		32
#define kLongStringLength	8192
#define kMediumStringLength	1024
#define kShortStringLength	256

//  typedefs:
typedef char *charPtr;
typedef double *doublePtr;
typedef int *intPtr;
typedef long int *longintPtr;
typedef char keyword[kKeywordLength];
typedef keyword *keywordPtr;
typedef unsigned short *ushortPtr;
typedef void *voidPtr;

// prototypes:
void IndentStrm(ostream &os, int indent = 0);
double sign(double a, double b);
void shift(double &a, double &b, double &c, double d);
bool CycleMod(int *A, int dim, int mn, int mx);

#endif
