/******************************************************************************
 PhyloGenApp.cpp

				PhyloGenApp Class
	
	Copyright  2002 Andrew Rambaut, University of Oxford. All rights reserved.

 ******************************************************************************/

#include <fstream>
#include <string.h>
#include <time.h>

#include "PhyloGenApp.h"
#include "PhyloGenEngine.h"
#include "PhyloGenEngineCaller.h"

#include "CHTMLReporter.h"
#include "CTextReporter.h"
#include "CTextWriter.h"
#include "CTextProgress.h"

#include "MEMaths.h"
#include "CRandom.h"

//#include "TextProgress.h"

// ---------------------------------------------------------------------------------
//		 PhyloGenApp
// ---------------------------------------------------------------------------------

PhyloGenApp::PhyloGenApp() : CApplication()
{
	MERandom::setSeed(time(NULL));
	CRandom::setSeed(time(NULL));
	
	strcpy(mPrompt, "PhyloGen> ");
	
	mEngine = new PhyloGenEngine();
	mEngineCaller = new PhyloGenEngineCaller(this, mEngine);
}

PhyloGenApp::~PhyloGenApp()
{
}

// ---------------------------------------------------------------------------------
//		 PhyloGenApp::writeTitle
// ---------------------------------------------------------------------------------

void PhyloGenApp::writeTitle() 
{
	CReportRecord *report = new CReportRecord("PhyloGen v1.1");
	CParagraphElement *para = new CParagraphElement();
	para->add("2002, Andrew Rambaut, Department of Zoology, ");
	para->addLineBreak();
	para->add("University of Oxford, Oxford, UK. ");
	para->addLineBreak();
	para->add("Please report any bugs or suggestions to the author.");
	para->addLineBreak();
	para->add("Email: andrew.rambaut@zoo.ox.ac.uk");
	para->addLineBreak();
	report->add(para);

	mResultsReporter->writeReport(report);
			
	delete report;
}

// ---------------------------------------------------------------------------------
//		 PhyloGenApp::setProgress
// ---------------------------------------------------------------------------------

void PhyloGenApp::setProgress(CProgress *inProgress) 
{
	mEngine->setProgress(inProgress);
}

// ---------------------------------------------------------------------------------
//		 PhyloGenApp::processFile
// ---------------------------------------------------------------------------------

CReportRecord *PhyloGenApp::processFile(CReader *inReader, bool inProcessCommands) 
{
	CReportRecord* report = new CReportRecord();
		
	return report;
}

