/******************************************************************************

Phylogeny Generator (PhyloGen) v1.0
Copyright (C) 2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of the PhyloGen program.

    PhyloGen is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    PhyloGen is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 PhyloGenApp.h

		Interface for the PhyloGenApp Class
	
 ******************************************************************************/

#ifndef _PHYLOGEN_APP_H_
#define _PHYLOGEN_APP_H_

#include "CApplication.h"

class PhyloGenEngine;
class CReader;
class CProgress;

class PhyloGenApp : public CApplication {
	protected:
		PhyloGenEngine*			mEngine;
	
	public:
								PhyloGenApp();
		virtual 				~PhyloGenApp();

		virtual void			writeTitle();
		virtual void			setProgress(CProgress *inProgress);

		virtual CReportRecord*	processFile(CReader *inReader, bool inProcessCommands);
};

#endif /* _PHYLOGEN_APP_H_ */
