/******************************************************************************

Phylogeny Generator (PhyloGen) v1.0
Copyright (C) 2002 Andrew Rambaut, 
Department of Zoology, University of Oxford, UK.

http://evolve.zoo.ox.ac.uk/
mailto:andrew.rambaut@zoo.ox.ac.uk

This file is part of the PhyloGen program.

    PhyloGen is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    PhyloGen is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolEvolLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 PhyloGenEngineCaller.h

		Interface for the PhyloGenEngineCaller Class

 ******************************************************************************/

#ifndef _PHYLOGEN_ENGINE_CALLER_H_
#define _PHYLOGEN_ENGINE_CALLER_H_

#include "PhyloGenEngine.h"
#include "CEngineCaller.h"
#include "CCommandRecord.h"
#include "CReportRecord.h"

class PhyloGenEngineCaller : public CEngineCaller {
	protected:
		PhyloGenEngine 		*mEngine;
		
	public:
		PhyloGenEngineCaller(CApplication *inApplication, PhyloGenEngine *inEngine);
		
		virtual CReportRecord*	executeCommand(CCommandRecord *inCommand);
		
	protected:
		virtual CReportRecord*	doBirthDeath(CCommandRecord *inCommand);
		virtual CReportRecord*	doSpatial(CCommandRecord *inCommand);
		virtual CReportRecord*	doEpisodic(CCommandRecord *inCommand);
		virtual CReportRecord*	doAddGrowth(CCommandRecord *inCommand);
		virtual CReportRecord*	doAddConstant(CCommandRecord *inCommand);
		virtual CReportRecord*	doAddExtinction(CCommandRecord *inCommand);
		virtual CReportRecord*	doClearEpisodes(CCommandRecord *inCommand);
		virtual CReportRecord*	doGenerate(CCommandRecord *inCommand);
		virtual CReportRecord*	doReconstruct(CCommandRecord *inCommand);
		virtual CReportRecord*	doSample(CCommandRecord *inCommand);
		virtual CReportRecord*	doStatus(CCommandRecord *inCommand);
		virtual CReportRecord*	doShape(CCommandRecord *inCommand);
		virtual CReportRecord*	doWritePhylogenies(CCommandRecord *inCommand);
		virtual CReportRecord*	doDrawLTTPlot(CCommandRecord *inCommand);
		virtual CReportRecord*	doDrawBalancePlot(CCommandRecord *inCommand);
		virtual CReportRecord*	doDrawPhylogeny(CCommandRecord *inCommand);
		virtual CReportRecord*	doDrawSpatial(CCommandRecord *inCommand);

		virtual CReportRecord*	doHelp(CCommandRecord *inCommand);
		virtual void			doCommandHelp(CCommandRecord *inCommand, CReportRecord* ioReport);
		
};

#endif /* _PHYLOGEN_ENGINE_CALLER_H_ */
